#include <stdio.h>
#include <sys/time.h>

#define MINIMP3_IMPLEMENTATION

#include "minimp3.h"

int main() {
    static mp3dec_t mp3d;
    mp3dec_init(&mp3d);

    mp3dec_frame_info_t info;

    FILE *input = fopen("out.mp3", "r");
    FILE *output = fopen("out.pcm", "w");
    uint8_t buffer[128];
    int f_loc = 0;
    short pcm[MINIMP3_MAX_SAMPLES_PER_FRAME];

    struct timeval time;
    gettimeofday(&time, NULL);
    unsigned long long microsec = ((unsigned long long)time.tv_sec * 1000000) + time.tv_usec;

    int loops = 0;

    while (!feof(input) && fread(buffer, 1, 128, input) > 0) {
        size_t samples = (size_t)mp3dec_decode_frame(&mp3d, buffer, 128, pcm, &info);

        f_loc += info.frame_bytes;
        fseek(input, f_loc, SEEK_SET);

        if (samples > 0)
            fwrite(pcm, sizeof(pcm[0]), samples * info.channels, output);

        //printf("Finished loop %d\n", ++loops);
    }

    gettimeofday(&time, NULL);
    microsec = (((unsigned long long)time.tv_sec * 1000000) + time.tv_usec) - microsec;

    printf("Decoding MP3... Done! (%.2f secs)", microsec / 1000000.0);

    fclose(input);
    fclose(output);

    return 0;
}